# -----------------------------------------------------------------------------
package admin_add_a_tree;
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# History :
# 
# -- 2001 Feb 23: 
#          
# -- 
# 
# -----------------------------------------------------------------------------

use strict;
use vars qw(@ISA @EXPORT);

use admin_bits;
use config;
use debug;
use exceptions;

# -----------------------------------------------------------------------------

require Exporter;

@ISA = qw(Exporter);
@EXPORT = qw(print_add_tree_form
             actually_add_tree);

# -----------------------------------------------------------------------------
# -- MODULE/PACKAGE VARS :
# -----------------------------------------------------------------------------

my $root         = &root;
my $html_lib_dir = &html_lib_dir;

# -----------------------------------------------------------------------------
# -- EXPORTS :

sub print_add_tree_form () {

    my $textline;

    # -- print form for new one :

    open (FORM, "$html_lib_dir/admin_add_tree_form.html_src")
        || &raise_stop_exception("Can't open admin_add_tree_form");

    while($textline = <FORM>) {
        print $textline;
      }

    close (FORM);
  }


# -----------------------------------------------------------------------------


sub actually_add_tree () {

  my $README = shift;
  my $DENY = shift;
  my $ALLOW = shift;
  my $NEWTREE = shift;

    if ($NEWTREE =~ m/[^a-zA-Z0-9\_]/) {
        &raise_info_exception("no way Jose!!!!!!!!!!!");
      }

    mkdir ("$root/_$NEWTREE", 0777)
        || &raise_stop_exception("Can't mkdir: $NEWTREE");

    open (README, ">$root/_$NEWTREE/README.node")
        || &raise_integrity_exception("Can't write file: " . 
                                      "$NEWTREE/README.node");
    print README $README;
    close(README);

    open (ALLOW, ">$root/_$NEWTREE/USERS.ALLOW")
        || &raise_integrity_exception("Can't write file: " . 
                                      "$NEWTREE/USERS.ALLOW");
    print ALLOW $ALLOW;
    close(ALLOW);

    open (DENY, ">$root/_$NEWTREE/USERS.DENY")
        || &raise_integrity_exception("Can't write file: $NEWTREE/USERS.DENY");
    print DENY $DENY;
    close(DENY);

    my $title_refresh = &refresh_to_admin_login("Made new tree:");

    print $title_refresh;

##    print "\n<H1>Made new tree:</H1>";


    print "\n<H2>Name:</H2><TT>$NEWTREE</TT>";
    print "\n<H2>Readme:</H2>";
    print "\n<PRE>$README</PRE>";
    print "\n<H2>Allow:</H2>";
    print "\n<PRE>$ALLOW</PRE>";
    print "\n<H2>Deny:</H2>";
    print "\n<PRE>$DENY</PRE>";
  }


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
