# -----------------------------------------------------------------------------

package Doc;

# -----------------------------------------------------------------------------
# History :
# 
# -- 2001 Nov 01:
#          
# -----------------------------------------------------------------------------

use strict;
use config;

# -----------------------------------------------------------------------------


my $printed_html_hdr = 0;
my $printed_doc_hdr  = 0;


# -----------------------------------------------------------------------------
# -- PUBLIC :  CONSTRUCTOR, DESTRUCTOR :
# -----------------------------------------------------------------------------

# -- 

sub new {                        

  my $class       = shift;

    my $self = { };              

    bless($self, $class);             

    $self->{DOCBODY}  = "";
    $self->{FOOTER}   = &new_footer();

    return $self;
  }


# -----------------------------------------------------------------------------


sub html_hdr {
    my $self = shift;

    my $bh_one   = shift;
    my $bh_two   = shift;
    my $bh_three = shift;

    $self->{BEGINHTML} = &begin_html($bh_one, $bh_two, $bh_three);  
  }


# -----------------------------------------------------------------------------


sub doc_hdr {
  my $self        = shift;
  my $header_type = shift;           
  my $s           = shift;
  my $USERNAME    = shift;
  my $TREE        = shift;
  my $LOCATION    = shift;
  my $PARENT      = shift;
 
    if ($header_type eq "headerstd") {
        $self->{HEADER} = &new_std_header($USERNAME, 
                                          $TREE, $LOCATION, $PARENT);
      }
    elsif ($header_type eq "headersimple") {
        $self->{HEADER} = &new_simple_header();
      }
    else {
        $self->{HEADER} = &new_simple_header();
      }
  }


sub doc_hdr_2 {
  my $self        = shift;
  my $header_type = shift;           
  my $s           = shift;
  my $PARENT      = shift;

    my $USERNAME = $s->attr("USERNAME");
    my $TREE     = $s->attr("TREE");
    my $LOCATION = $s->attr("LOCATION");
 
    if ($header_type eq "headerstd") {
        $self->{HEADER} = &new_std_header($USERNAME, 
                                          $TREE, $LOCATION, $PARENT);
      }
    elsif ($header_type eq "headersimple") {
        $self->{HEADER} = &new_simple_header();
      }
    else {
        $self->{HEADER} = &new_simple_header();
      }
  }


# -----------------------------------------------------------------------------

sub append() {
    my $self = shift;
    my $text = shift;

    $self->{DOCBODY} .= $text;
  }

# -----------------------------------------------------------------------------

sub flush() {
    my $self = shift;

    unless ($printed_html_hdr) {print $self->{BEGINHTML}};
    unless ($printed_doc_hdr)  {print $self->{HEADER}};

    $printed_html_hdr = 1;
    $printed_doc_hdr  = 1;

    print $self->{DOCBODY};

    $self->{DOCBODY} = "";
  }

# -----------------------------------------------------------------------------


sub wen() {
    my $self = shift;
  
    unless ($printed_html_hdr) {print $self->{BEGINHTML}};
    unless ($printed_doc_hdr)  {print $self->{HEADER}};
    print $self->{DOCBODY};
    print $self->{FOOTER};
  }


# -----------------------------------------------------------------------------
# -- BITS : 
# -----------------------------------------------------------------------------


my $server = "http://talby.csu.umist.ac.uk";


my $header_usual_picture =  
    "<IMG SRC=\"http://talby.csu.umist.ac.uk/isd_light_short_fat.jpg\">";


my $header_usual_links =
      "<A HREF=\"/~isd/_doculib/about.html\">About</A>" . " | " 
    . "<A HREF=\"$server/~isd/_doculib/devel.html\">Devel</A>" . " | "
    . "<A HREF=\"$server/~isd/_doculib/faq.html\">FAQ</A>" . " | "
    . "<A HREF=\"$server/~isd/_doculib/help.html\">Help</A>" . " | " 
    . "<A HREF=\"$server/~isd/_doculib/issues.html\">Issues</A>" . " | " 
    . "<A HREF=\"" . &cgi_root_dir . "/login_form.pl\">Login Page</A>" . " | " 
    . "<A HREF=\"$server/~isd/_doculib/plans.html\">Plans</A>" . " | "
    . "<A HREF=\"$server/~isd/_doculib/talk.html\">Talk</A>" . " | " 
    . "<A HREF=\"$server/~isd/_doculib/usage.html\">Usage</A>";


my $footer_usual_picture = 
       "<IMG SRC=\"/penguin-acad.gif\">";


my $footer_usual_text_and_links =
       "This page was generated by "
     . "<A HREF=\"http://www.perl.org\" TARGET=\"_top\">perl</A>;  "
     . "it was developed under "
     . "<A HREF=\"http://www.linux.org\" TARGET=\"_top\">Linux</A> "
     . "and is powered by S&N at ISD at UMIST.";


# -----------------------------------------------------------------------------
# -- PUBLIC :  RETURN METHODS :
# -----------------------------------------------------------------------------


sub new_simple_header() {

    return "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=\"100%\">"
         . "<TR><TD BGCOLOR=\"white\">" 
         . $header_usual_picture
         . "</TD><TD WIDTH=\"80%\" VALIGN=\"top\">" 
         . "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=\"100%\">"
         . "<TR><TD ALIGN=\"right\">" 
         . $header_usual_links
         . "</TD></TR><TR><TD></TD></TR></TABLE>"
         . "</TD></TR></TABLE>";
  }


sub new_footer() {

    return "<TABLE WIDTH=\"100%\" BORDER=0 CELLSPACING=0 CELLPADDING=10><TR>" 
         . "<TD WIDTH=\"75%\" VALIGN=\"bottom\" BGCOLOR=#EEEEEE>"
         . "<FONT SIZE=1 FACE=courier><B>"
         . $footer_usual_text_and_links
         . "</TD>"
         . "<TD WIDTH=\"15%\" ALIGN=\"center\" VALIGN=\"top\" BGCOLOR=#EEEEEE>"
         . $footer_usual_picture
         . "</TD></TR></TABLE>";
  }


sub new_std_header() {

    my $USERNAME  = shift;
    my $TREE      = shift;
    my $LOCATION  = shift;
    my $PARENT    = shift;

    return "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=\"100%\">"
         . "<TR><TD BGCOLOR=\"white\">" 
         . $header_usual_picture
         . "</TD><TD WIDTH=\"80%\" VALIGN=\"top\">" 
         . "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=\"100%\">"
         . "<TR><TD ALIGN=\"right\">" 
         . $header_usual_links
         . "</TD></TR><TR><TD>"
         . &environment_table($USERNAME, $TREE, $LOCATION, $PARENT)
         . "</TD></TR></TABLE>"
         . "</TD></TR></TABLE>";
  }


# -----------------------------------------------------------------------------
# -- PRIVATE :
# -----------------------------------------------------------------------------


sub begin_html() {
  
  my $head_str     = shift @_;
  my $title_text   = shift @_;
  my $three_string = shift @_;

    my $string = "";

    $string .= "Content-type: text/html\n";
    $string .= $head_str . "\n\n";

    $string .= "\n<HTML><HEAD><TITLE>$title_text</TITLE>$three_string"
            .  "\n<LINK REL=\"stylesheet\" TYPE=\"text/css\" " 
            .  "HREF=\"" . &css_sheet . "\">"
            .  "\n</HEAD>"
            .  "\n<BODY BGCOLOR=\"white\">\n";

    return $string;
  }


sub environment_table() {

    my $USERNAME  = shift;
    my $TREE      = shift;
    my $LOCATION  = shift;
    my $PARENT    = shift;

    # -- some adjustment of PARENT may be necessary :

    if ($PARENT eq &no_parent) {
        $PARENT = "At root.\n";
      }
    elsif ($PARENT eq "/") {
        $PARENT = "<A HREF=\"" . &cgi_root_dir . "navigate.pl\?" 
                           . "NAVIGATE\=NAVIGATE\&" 
                           . "TREE\=$TREE\&" 
                           . "LOCATION\=$PARENT\&" 
                           . "USERNAME\=$USERNAME\&"
                           . "VIEW\=" . &default_view
                           . "\">" . "Root" . "</A>\n";
      }
    else {
        $PARENT = "<A HREF=\"" . &cgi_root_dir . "navigate.pl\?" 
                           . "NAVIGATE\=NAVIGATE\&" 
                           . "TREE\=$TREE\&" 
                           . "LOCATION\=$PARENT\&" 
                           . "USERNAME\=$USERNAME\&"
                           . "VIEW\=" . &default_view
                           . "\">" . $PARENT . "</A>\n";
      }


    return "<TABLE CELLSPACING=0 CELLPADDING=0 BORDER=0>"
         . "<TR><TD><B>Username</B></TD><TD WIDTH=\"4%\"><B> : </B></TD>" 
         . "<TD><TT>$USERNAME</TD></TR>"
         . "<TR><TD><B>Location</B></TD><TD><B> : </B></TD>" 
         . "<TD><TT>$LOCATION</TD></TR>"
         . "<TR><TD><B>Parent</B></TD><TD><B> : </B></TD>" 
         . "<TD><TT>$PARENT</TD></TR>"
         . "<TR><TD><B>Tree</B></TD><TD><B> : </B></TD>"
         . "<TD><TT>$TREE</TD></TR>"
         . "</TABLE>";
  }


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------


