#!/usr/bin/perl -w 


my $ps_dir = "__ps";
my $path   = ".";
my $root   = `pwd`;
chomp($root);

print "\n pwd: $root";

# -- delete old files if output-directory exists :

if (-e $ps_dir) {
    opendir(PSDIR, $ps_dir) || die "Can't opendir: $ps_dir";
    foreach $file (readdir(PSDIR)) {
        if ($file eq ".") {next}
        if ($file eq "..") {next}
        unlink "$ps_dir/$file" || die "Can't unlink: $ps_dir/$file";
      }
    closedir($ps_dir);
  }

# -- if output-directory does not exist, then create it :

unless (-e $ps_dir) {
    mkdir($ps_dir, 0700) || die "Can't mkdir: $ps_dir";
  }

# -- recursively print each .pl and .pm file to output-directory :

&print_recur_dir_to_ps(".");


# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------

sub print_recur_dir_to_ps() {

  my $dir = shift;

  print "\n prdtp called on dir: $dir";

    my $file;

    opendir(DIR, "$path/$dir") || die "prdtp: can't open dir: $path/$dir";
    foreach $file (readdir(DIR)) {
        if ($file eq ".") {next}
        if ($file eq "..") {next}
        if ($file =~ m/\~$/) {next}        

        if (-d $file) {
            print "\n dir found: $file";
            &print_recur_dir_to_ps("$path/$dir/$file");
          }

        unless (($file =~ m/\.pl$/) || ($file =~ m/\.pm$/)) {
            next;
          }

        print "\n Printing $file to $root/$ps_dir/$file\.ps";
            system("a2ps -Eplain --portrait --columns=1 " . 
                   "-o $root/$ps_dir/$file\.ps $root/$dir/$file");
      }
  }

# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------
