# -----------------------------------------------------------------------------
package date_time;
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# History :
# 
# -- 2001 Nov 09 :  remnants of client_bits from older versions 
#                   of DocULib...
# 
# -----------------------------------------------------------------------------

use strict;
use vars qw(@ISA @EXPORT);

# -----------------------------------------------------------------------------

require Exporter;

# -----------------------------------------------------------------------------

use config;
use Time::Local;


# -----------------------------------------------------------------------------

@ISA    = qw(Exporter);
@EXPORT = qw(date_time
             date_time_sensible);

# -----------------------------------------------------------------------------
my $html_lib_dir = &html_lib_dir;
# -----------------------------------------------------------------------------


sub date_time_sensible() {
  my $string = shift;

    my ($dd, $mm, $yyyy);
    ($dd, $mm, $yyyy) = split(/\//, $string);

    unless (   ($dd   =~ m/^\d\d$/) 
        && ($mm   =~ m/^\d\d$/) 
        && ($yyyy =~ m/^\d\d\d\d$/)
       ) {
        return 0;
      }

    
    my ($day, $month, $year) = (localtime)[3,4,5];

    $month += 1;
    $year  += 1900;

#  print "\n<BR> DMY: $dd, $mm, $yyyy <BR>\n";
#  print "\n<BR> DMY: $day, $month, $year <BR>\n";

    my $epoch_sec_ddmmyyyy     = timelocal(undef, undef, undef,
                                           $dd,   $mm-1, $yyyy-1900);
    my $epoch_sec_day_mon_year = timelocal(undef, undef, undef,
                                           $day, $month-1, $year-1900);

    unless ($epoch_sec_ddmmyyyy <= $epoch_sec_day_mon_year) {
        return 0;
      }

    return 1;
  }


sub date_time() {

  my $epoch_time = shift;

    my ($year, $month, $day_m, $hours, $minutes);

    (undef, $minutes, $hours, $day_m, $month, $year, 
     undef, undef, undef) = localtime($epoch_time);

    $year  = $year + 1900;
    $month = $month + 1;
    if ($minutes < 10) {$minutes = "0$minutes"}

    return "$year/$month/$day_m ($hours:$minutes)"
  }


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
