# -----------------------------------------------------------------------------
package config;
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# History :
# 
# -- 2000 Nov 27: 
#          
# -- 
# 
# -----------------------------------------------------------------------------

use strict;
use vars qw(@ISA @EXPORT);

# -----------------------------------------------------------------------------

require Exporter;

# -----------------------------------------------------------------------------

@ISA    = qw(Exporter);
@EXPORT = qw(cgi_root_dir
             passwd_dir
             passwd_admin_dir
             cookie_dir
             admin_cookie_dir
             html_lib_dir
             errors_html_lib_dir
             default_view
             log_dir
             tmp_dir
             debug_level
             css_sheet
             set_tree tree root available_trees 
             no_parent);


# -----------------------------------------------------------------------------
# -- LOCAL VARIABLES :

my $tree = "None";


# -----------------------------------------------------------------------------
# -- EXPORT :
# -----------------------------------------------------------------------------

###sub debug_level {return 3}
sub debug_level {return 0}
    # ...0 is none, 1 is important stuff, ..., 10 is everything;

sub css_sheet {
    return "http://talby.csu.umist.ac.uk/doculib.css";
  }

sub admin_cookie_dir {
    return "/var/local/doc_U_base_admin/";
  }

sub cookie_dir {
    return "/var/local/doc_U_base/";
  }

sub default_view {
    return "REVCHRON";
  }

sub errors_html_lib_dir {
    return "/home/httpd/cgi-bin/doc_lib_b9/ERRORS/";
  }

sub passwd_dir {
    return "/home/httpd/cgi-bin/doc_lib_b9/PASSWD/";
  }

sub passwd_admin_dir {
    return "/home/httpd/cgi-bin/doc_lib_b9/PASSWD_ADMIN/";
  }

sub html_lib_dir {
    return "/home/httpd/cgi-bin/doc_lib_b9/HTML_LIB/";
  }

sub log_dir {
    return "/var/local/doc_U_base/";
  }

sub tmp_dir {
    return "/var/local/doc_U_base/tmp/";
  }

sub cgi_root_dir {
    return "http://talby.csu.umist.ac.uk/cgi-bin/doc_lib_b9/";
  }

sub no_parent {
    return "Created";
  }

sub root {
    return "/var/local/doc_U_base/";
  }

# -----------------------------------------------------------------------------

sub set_tree() {
    $tree = $_[0];
  }

sub tree {
    return $tree;
  }

# -----------------------------------------------------------------------------

sub available_trees {

    my $filename;
    my $root = &root;
    my @trees;

    opendir(AVAILTREES, $root)
        || &raise_logout_exception("root_dir_unavailable"); 

    foreach $filename (sort readdir(AVAILTREES)) {
        if ($filename eq ".") {next}
        if ($filename eq "..") {next}    
        if ($filename eq "tmp") {next}
        if (-l "$root$filename") {next}
        open (FILE, "$root$filename") 
            || &raise_options_exception("Can't open file: $root$filename");
            unless (-d FILE) {next}
        close(FILE);

        push(@trees, $filename);
      }
    return @trees;
  }

# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------

