# -----------------------------------------------------------------------------
package swish_related;
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# History :
# 
# -- 2001 Aug 02: 
#          
# -----------------------------------------------------------------------------

use strict;
use vars qw(@ISA @EXPORT);

# -----------------------------------------------------------------------------

require Exporter;

# -----------------------------------------------------------------------------

use Time::Local;

use config;
use Thingy;

# -----------------------------------------------------------------------------

@ISA    = qw(Exporter);
@EXPORT = qw(swish_res_to_thingies
             swish_res_to_branches
             );

# -----------------------------------------------------------------------------

my $root         = &root;
my $cgi_root_dir = &cgi_root_dir;


# -----------------------------------------------------------------------------
# --

sub swish_res_to_branches {

  my $except    = shift;
  my $TREE      = shift;
  my $swish_res = shift;

    my @results    = ();
    my @sw_results = split(/\n/, $swish_res);

    foreach (@sw_results) {

        # -- dump comments and last line (a dot by itself) :
        if ($_ =~ m/^\s*\#/) {next;}
        if ($_ =~ m/^\s*\.\s*/) {next;}

        # -- an error has occured (which includes zero results) :
        if ($_ =~ m/^\s*err\s*\:/) {
            $except->raise_stop("$_");            
          }

        my @bits = split(/\s+/, $_);

        $bits[1] =~ s/README\.node$//;
        $bits[1] =~ s/^$root//;
        $bits[1] =~ s/^$TREE//;

        my $result = { };

        $result->{LOCATION} = $bits[1];

        push(@results, $result);
      }
  
    return \@results;
  }


# -----------------------------------------------------------------------------
# -- 

sub swish_res_to_thingies {

  my $except    = shift;
  my $TREE      = shift;
  my $swish_res = shift;

    my @thingies   = ();
    my @sw_results = split(/\n/, $swish_res);

    foreach (@sw_results) {

        # -- dump comments and last line (a dot by itself) :
        if ($_ =~ m/^\s*\#/) {next;}
        if ($_ =~ m/^\s*\.\s*/) {next;}

        # -- an error has occured (which includes zero results) :
        if ($_ =~ m/^\s*err\s*\:/) {
            $except->raise_stop("$_");            
          }

        my @bits = split(/\s+/, $_);

        my $entry    = $bits[1];
        my $location = $bits[1];
        my $show_str = $bits[1];

        $entry =~ s/^$root//;
        $entry =~ s/^$TREE//;
        $entry =~ s/\.README$//;
        $entry =~ s/.*\///;

        $location =~ s/\.README$//;
        $location =~ s/\/[^\/]+$/\//;

        $location =~ s/^$root//;
        $location =~ s/^$TREE//;

##print "\n<BR>TREE: $TREE, location: $location, entry: $entry";

        my $result = { };
        my $thingy = Thingy->down_new($TREE, $location, $entry);

        $result->{LOCATION} = $location;
        $result->{FILE}     = $entry;
        $result->{THINGY}   = $thingy;
        
        push(@thingies, $result);
      }

    return \@thingies;
  }


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
