#!/usr/bin/perl -w -I ./_Doc -I ./_cgi_lib -I _sal -I _sal_lib -I ./_config

use log;
use qsm_mod;

use CDF;
use Cookie;
use Doc;
use Exception;
use State;

# -----------------------------------------------------------------------------
# -- INITIALISATION :

my $doc     = Doc->new();
my $cookies = Cookie->new($doc);
my $except  = Exception->new();
my $s       = State->new();
my $cdf     = CDF->new($cookies, $doc, $except, $s, 
                       $s->attr("TREE"), $s->attr("LOCATION"));


# -----------------------------------------------------------------------------
# -- VALIDATE REQUEST :

my $admin = "";

if ($cookies->valid_admin_cookie($doc, $except)){
    $admin = "am_admin";
  }
else {
    unless ($cookies->valid_cookie($doc, $except, $s->attr("USERNAME"))) {
        $doc->html_hdr("", "Navigation Widget", "");
        $doc->doc_hdr_2("headerstd", $s, "???");
        $doc->flush();

        $except->raise_logout($cookies, $doc, "invalid_cookie")
      }
  }


# -----------------------------------------------------------------------------
# -- PERMISSIONS :

unless (($admin eq "am_admin") || 
        ($cdf->read_permission_granted($except, $s))) {

    $doc->html_hdr("", "No permission!", "");
    $doc->doc_hdr_2("headerstd", $s, "???");
    $doc->flush();

    $except->raise_options($doc, $s, "not_permitted")
  }


# -----------------------------------------------------------------------------
# -- DEBUG :

my $debug = Debug->new(1, "Important ENV variables");

$debug->item("FILE: " . $s->attr("FILE"));
$debug->wen($doc);


# -----------------------------------------------------------------------------
# --- which mime-type is it?

@qs_mime_type = split(/\./, $s->{FILE});
$qs_mime_type = $qs_mime_type[scalar(@qs_mime_type)-1];


# -----------------------------------------------------------------------------
# -- SQUIRT :

&copy_html_header_to_stdout($doc, $qs_mime_type);
&log_read($s->{USERNAME});
&copy_requested_file_to_stdout($doc, $s->attr("FILE"));

# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------






