#!/usr/bin/perl -w -I ./_config

use strict;

# -- my libs :

use config;


# -----------------------------------------------------------------------------
# -- arrive and put the kettle on :

my $root        = &root();
my $eR_template = &get_entry_READMEs_template();

my $file;

chdir($root)
    || die "\n Can't cd to root: $root\n";

opendir(DIR, $root);


# -----------------------------------------------------------------------------
# -- whizz through all files in our root dir and create SWISH config (if 
#    necessary) and index files :

foreach $file (readdir(DIR)) {

    # -- unless its a directory and begins with "_" skip it :

    unless ($file =~ m/^\_/) {next;}
    unless (-d $file)        {next;}
    print "\n looking at tree: $file";

    # -- unless config file exists, create one from the 
    #    template :

    unless (-e "$root/$file/SWISH.config--entry-READMEs") {
        &create_entry_readme_config_from_template($file, $eR_template);
      }

    # -- do those new index files baby :

    chdir($file) || 
        die "\n Can't cd to tree: $file\n";

    # -- make new branch-readme index :
    #`/usr/local/bin/swish-e -c ..........................`;

    # -- make new entry-readme index :
    `/usr/local/bin/swish-e -c SWISH.config--entry-READMEs`;

    chdir("..") 
        || die "\n Can't return to root dir: $root\n";
  }


# -----------------------------------------------------------------------------
# -- tidy up, sit down with a cup of tea :

closedir(DIR);

print "\n\n Bye!\n\n";


# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------


sub get_entry_READMEs_template() {

  my $textline = "";

    my @template;

    open(TEMPLATE, "$root/SWISH.config--entry-READMEs.template")
        || die "\n Can't get entry-READMEs template!\n";

    while ($textline = <TEMPLATE>) {
        ###print "\n ...got eR temp...";
        push(@template, $textline);
      }
    print "\n Got " . scalar(@template) . " lines";
    close(TEMPLATE);

    return \@template;
  }

# -----------------------------------------------------------------------------

sub create_entry_readme_config_from_template() {

  my $tree     = shift;
  my $template = shift;

    my $temp;

    print "\n Creating SWISH config file for tree: $tree";

    open(CONFIG, ">$root/$tree/SWISH.config--entry-READMEs")
        || die "\n\n Can't open new config file for tree: $tree";
    foreach (@$template) {
        ###print "\n ...writing to SWISH.config--entry-READMEs...";
        if ($_ =~ m/\$TREE/) {
            $temp = $_;
            $temp =~ s/\$TREE/$tree/;
            print CONFIG $temp;
          }
        else {
            print CONFIG $_;
          }
      }
    close(CONFIG);
  }


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
