# -----------------------------------------------------------------------------
package up_mod;
# -----------------------------------------------------------------------------

use strict;
use vars qw(@ISA @EXPORT);

# -----------------------------------------------------------------------------
# History :
# 
# -- 2000 Nov 28: 
#          
# -- 2001 Mar 27:  added subroutine "upload_file";
# 
# -----------------------------------------------------------------------------

use config;
use date_time;
use thingies;

# -----------------------------------------------------------------------------

require Exporter;

# -----------------------------------------------------------------------------

@ISA    = qw(Exporter);

@EXPORT = qw(
             upload_form
             upload_nv_form
             refresh_to_navigate
             check_ok_to_move_from_tmp
             check_ok_to_move_nv_from_tmp
             check_constraints_on_nv
             move_from_tmp
             build_and_write_thingy
             build_and_write_nv_thingy

             clean_file_name
             clean_doc_root
             really_do_this
             upload_file);

# -----------------------------------------------------------------------------
# -- MODULE/PACKAGE VARS :

my $root         = &root;
my $cgi_root_dir = &cgi_root_dir;
my $tmp_dir      = &tmp_dir;


# -- we need the time for uploading our document which has an explicit 
#    time stamp :

my $time = time;


# -----------------------------------------------------------------------------
# -- EXPORT :
# -----------------------------------------------------------------------------

# -- print upload form :

sub upload_form() {

  my $html = shift;
  my $s    = shift;

    my $USERNAME = $s->attr("USERNAME");
    my $REALNAME = $s->attr("REALNAME");
    my $TREE     = $s->attr("TREE");
    my $LOCATION = $s->attr("LOCATION");
 
    my $string = "";

    $string .= "<H1>Upload Form</H1>\n";

    $string .= "<P><B>\n" 
        . "You must upload at least one of: File (def), File (view); \n"
        . "you must give a name for your upload:  Entry."
        . "</B></P>";

### $string .= $html->startform("POST", "upload.pl", &CGI::MULTIPART);
### ...the above won't work with gecko (ok with IE and netscape 4.7), so
###    use the below instead:

    $string .= "\n\n";
    $string .= "<FORM NAME=\"uploadnewdocform\" METHOD=\"POST\"" 
            .  " ACTION=\"upload.pl\" ENCTYPE=\"multipart/form-data\">\n";

    $string .= "<PRE>\n";

    $string .= "<FONT SIZE=4>Entry       : </FONT>";
    $string .= $html->textfield('THINGY', '', 35) . "\n";

    $string .= "<FONT SIZE=4>File (def)  : </FONT>";
    $string .= $html->filefield('FILE_DEF', '', 35) . "\n";

    $string .= "<FONT SIZE=4>File (view) : </FONT>";
    $string .= $html->filefield('FILE_VIEW', '', 35) . "\n";

    $string .= "<FONT SIZE=4>Author      : </FONT>";
    $string .= $html->textfield('AUTHOR', $REALNAME, 35) . "\n";

    $string .= "<FONT SIZE=4>Date Written: </FONT>";
    $string .= "<INPUT TYPE=\"text\""
            .  " NAME=\"DATEWRITTEN\" SIZE=\"10\"" 
            .  " MAXLENGTH=\"10\">";
    $string .= "<FONT SIZE=4>(dd/mm/yyyy)</FONT>\n";
    $string .= "<FONT SIZE=4>Keywords    : </FONT>";
    $string .= $html->textfield('KEYWORDS', '', 35) . "\n";

    $string .= "<FONT SIZE=4>Readme      : </FONT>";
    $string .= "<TEXTAREA name='README' rows=3 cols=50 wrap='physical'>" . 
          "</TEXTAREA>\n";

    $string .= "</PRE>\n";

    $string .= "<TABLE CELLSPACING=2 CELLPADDING=0 BORDER=1><TR>";
    $string .= "\n<TD VALIGN=\"top\" WIDTH=30%>";
    $string .= $html->submit('BUTTON', 'Send Me');
    $string .= $html->submit('BUTTON', 'Cancel');
    $string .= $html->reset('Reset');
    $string .= "\n</TD><TD VALIGN=\"top\">\n";
    $string .= "If you are uploading a big file (or the network is slow) "
            . "this may take a while:  during this time it is not possible to "
            . "show you progress (unless the browser does it independently of "
            . "the CGI scripts) so things may appear to lock up...";
    $string .= "\n</TD></TR></TABLE>\n";
  
    $string .= "\n" . $html->hidden('LOCATION', $LOCATION);
    $string .= "\n" . $html->hidden('TREE', $TREE);
    $string .= "\n" . $html->hidden('USERNAME', $USERNAME);
    $string .= "\n" . $html->hidden('REALNAME', $REALNAME);

    $string .= "\n<INPUT TYPE=\"hidden\" NAME=\"ACTION\" " 
            .  "VALUE=\"CHECK_UPLOAD\">";
  
    $string .= "\n" . $html->endform . "\n\n";

    return $string;
  }


# -----------------------------------------------------------------------------
# -- 

sub upload_nv_form() {

  my $html = shift;
  my $s     = shift;

    my $USERNAME = $s->attr("USERNAME");
    my $REALNAME = $s->attr("REALNAME");
    my $TREE     = $s->attr("TREE");
    my $LOCATION = $s->attr("LOCATION");

    my $THINGY    = $s->attr("THINGY");

    my $string    = "";
    my $nv_thingy = Thingy->down_new($TREE, $LOCATION, $THINGY);

    my $default_keywords = "";

    $string .= <<EENNDD;

<BR><BR><H1>Upload (New Version) Form</H1>
<BR><P>
To successfully modify an entry (upload a new version) you must upload
new versions of any existing representations of the document, e.g., 
both <B>definitive</B> and <B>viewonly</B> if both already exist.
</P><BR>

EENNDD

    $string .= $html->startform("POST", "upload.pl", &CGI::MULTIPART);

    $string .= "<PRE>\n";
    $string .= "<FONT SIZE=4>New version of    : <B>$THINGY</B></FONT>\n\n";

    $string .= "<FONT SIZE=4>File (def)        : </FONT>";
    $string .= $html->filefield('FILE_DEF', '', 35) . "\n";

    $string .= "<FONT SIZE=4>File (view)       : </FONT>";
    $string .= $html->filefield('FILE_VIEW', '', 35) . "\n";

    $string .= "<FONT SIZE=4>Author            : </FONT>";
    $string .= $html->textfield('AUTHOR', $REALNAME, 35) . "\n";

    $string .= "<FONT SIZE=4>Date Written      : </FONT>";
    $string .= "<INPUT TYPE=\"text\" 
                 NAME=\"DATEWRITTEN\" SIZE=\"10\" 
                 MAXLENGTH=\"10\">";
    $string .= "<FONT SIZE=4>(dd/mm/yyyy)</FONT>\n";

    $string .= "<FONT SIZE=4>Keywords          : </FONT>";
    foreach (@{$nv_thingy->keywords}) {$default_keywords .= "$_ "}
    $string .= $html->textfield('KEYWORDS', $default_keywords, 35) . "\n";

    $string .= "<FONT SIZE=4>Reason for change : </FONT>";
    $string .= "<TEXTAREA name='HISTORYAPPEND' rows=3 " 
            .  "cols=50 wrap='physical'>";
    $string .= "</TEXTAREA>\n";

    $string .= "</PRE>\n";

    $string .= $html->submit('BUTTON', 'Send Me');
    $string .= $html->submit('BUTTON', 'Cancel');
    $string .= $html->reset('Reset');

    $string .= $html->hidden('LOCATION', $LOCATION);
    $string .= $html->hidden('TREE', $TREE);
    $string .= $html->hidden('THINGY', $THINGY);
    $string .= $html->hidden('USERNAME', $USERNAME);
    $string .= $html->hidden('REALNAME', $REALNAME);

    $string .= "\n<INPUT TYPE=\"hidden\" NAME=\"ACTION\" " .
         "VALUE=\"CHECK_UPLOAD_NEW_VERSION\">";

    $string .= $html->endform;

    return $string;
  }


# -----------------------------------------------------------------------------
# --

sub refresh_to_navigate() {

  my $TREE     = shift @_;
  my $LOCATION = shift @_;
  my $username = shift @_;
  my $realname = shift @_;

    my $string = "";

    $string .= "\n\n<BR><BR>\n";
    $string .= "<CENTER><BIG>\n";

    $string .= "You will shortly be refreshed to the updated navigation page" 
            . "<FONT FACE=\"courier\">...</FONT>"
            . "<META HTTP-EQUIV=\"refresh\" content=\"10; "
            . "URL=" . $cgi_root_dir . "navigate.pl\?" 
                                     . "NAVIGATE\=NAVIGATE\&"
                                     . "VIEW\=" . &default_view . "\&"
                                     . "LOCATION\=$LOCATION\&" 
                                     . "TREE\=$TREE\&"
                                     . "USERNAME\=$username\&"  
                                     . "REALNAME\=$realname"  
            . "\"><BR>\n";

    $string .= "<FONT FACE=\"courier\">...</FONT>or " 
            . "<A HREF=\"" . $cgi_root_dir . "navigate.pl\?" 
                           . "NAVIGATE\=NAVIGATE\&"
                           . "VIEW\=" . &default_view . "\&"
                           . "LOCATION\=$LOCATION\&" 
                           . "TREE\=$TREE\&"
                           . "USERNAME\=$username\&" 
                           . "REALNAME\=$realname" 
            . "\">click here</A> to go immediately<BR>\n";

    $string .= "\n</BIG></CENTER>\n\n";

    return $string;
  }


# -----------------------------------------------------------------------------
# -- Clean...

sub clean_doc_root() {

    my $doc_root = shift;

    # -- eliminate spaces :
    $doc_root =~ s/\s/_/gs;

    return $doc_root;
  }


sub clean_file_name() {

  my $file = shift @_;

    # -- strip paths (IE likes to put C:\.......\my_file.suf) :

    $file =~ s/^.*\\//;
    $file =~ s/^.*\///;

    # -- eliminate spaces :
    $file =~ s/\s/_/gs;

    return $file;
  }


# -----------------------------------------------------------------------------
# -- 

sub move_from_tmp() {

  my $doc           = shift;
  my $except        = shift;
  my $TREE          = shift;
  my $LOCATION      = shift;
  my $doc_name_root = shift;
  my $pf_up_file    = shift;
  my $new_old       = shift;

    if ($pf_up_file =~ m/\S/) {

        # -- mv, or cp and rm, depending on partitions and unices and shells
        #    and things...

        rename("$tmp_dir$doc_name_root--$pf_up_file",
               "$root$TREE$LOCATION/$doc_name_root--" . 
                                    $time . "--" . "$pf_up_file")
            || $except->raise_integrity($doc,
                   "Can't rename file " . 
                   "$tmp_dir$doc_name_root--" . 
                   "$pf_up_file " .
                   "to " . 
                   "$root$TREE$LOCATION$doc_name_root--" . 
                                    $time . "--" . "$pf_up_file");

        # -- put symbolic, time-stamp-less links in :

        chdir("$root$TREE$LOCATION");

        unless ($new_old eq "NEW_VER") {
            symlink("$doc_name_root--$time--$pf_up_file", 
                    "$doc_name_root--$pf_up_file") 
                || $except->raise_integrity($doc, 
                       "Unable to create symlink: " . 
                       "$TREE$LOCATION/$doc_name_root--$pf_up_file");
          }
      }
  }


# -----------------------------------------------------------------------------
# -- 

sub build_and_write_nv_thingy() {

  my $doc             = shift;
  my $except          = shift;
  my $TREE            = shift;
  my $LOCATION        = shift;
  my $keywords        = shift;
  my $AUTHOR          = shift;
  my $REALNAME        = shift;
  my $DATEWRITTEN     = shift;
  my $history_append  = shift;
  my $doc_name_root   = shift;
  my $pf_up_file_def  = shift;
  my $pf_up_file_view = shift;


    my $nv_thingy = Thingy->up_new($TREE, $LOCATION, 
                                   $pf_up_file_def,
                                   $pf_up_file_view,
                                   $keywords, 
                                   $AUTHOR, $REALNAME, $DATEWRITTEN);

  $doc->append("\n<BR>up_new'ed Thingy");

    $nv_thingy->write_nv($doc, $except,
                         $TREE, $LOCATION, 
                         $doc_name_root, $time, $history_append);

  }


# -----------------------------------------------------------------------------
# -- 

sub build_and_write_thingy() {
   my $doc             = shift;
   my $except          = shift;
   my $TREE            = shift;
   my $LOCATION        = shift;
   my $keywords        = shift;
   my $AUTHOR          = shift;
   my $REALNAME        = shift;
   my $DATEWRITTEN     = shift;
   my $readme          = shift;
   my $doc_name_root   = shift;
   my $pf_up_file_def  = shift;
   my $pf_up_file_view = shift;

    if (($pf_up_file_def =~ m/\S/) || ($pf_up_file_view =~ m/\S/)) {

        my $up_thingy = Thingy->up_new($TREE, $LOCATION, 
                                       $pf_up_file_def, $pf_up_file_view,
                                       $keywords, $AUTHOR, $REALNAME, 
                                       $DATEWRITTEN);

        $up_thingy->write($doc, 
                          $TREE, $LOCATION, "$doc_name_root", $time, $readme);
      }
  }


# -----------------------------------------------------------------------------
# -- 

sub check_constraints_on_nv() {

  my $doc             = shift;
  my $except          = shift;
  my $s               = shift;

  my $pf_up_file_def  = shift;
  my $pf_up_file_view = shift;

    my $TREE          = $s->attr("TREE");
    my $LOCATION      = $s->attr("LOCATION");
    my $doc_name_root = $s->attr("DOCNAMEROOT");

    # -- must upload def if def already exists, ditto view :

    my $existing_thingy = Thingy->down_new($TREE, $LOCATION, $doc_name_root);

    unless (@{$existing_thingy->definitive}[0] eq "none") {
        unless ($pf_up_file_def =~ m/\S/) {
            $except->raise_options($doc, $s, 
                                   "Current version has a " . 
                                   "definitive/editable, hence you must " . 
                                   "upload one too!");
          }
        unless (@{$existing_thingy->definitive}[0] eq $pf_up_file_def) {
            $except->raise_options($doc, $s, 
                                   "For new versions, " . 
                                   "filenames cannot change!");
          }
      }

    unless (@{$existing_thingy->viewonly}[0] eq "none") {
        unless ($pf_up_file_view =~ m/\S/) {
            $except->raise_options($doc, $s, 
                                   "Current version has a view-only, " . 
                                   "hence you must upload one too!");
          }
        unless (@{$existing_thingy->viewonly}[0] eq $pf_up_file_view) {
            $except->raise_options($doc, $s, 
                                   "For new versions, " . 
                                   "filenames cannot change!");
          }
      }
 
  }


# -----------------------------------------------------------------------------
# -- 

sub check_ok_to_move_nv_from_tmp() {

  }


# -----------------------------------------------------------------------------
# -- 

sub check_ok_to_move_from_tmp() {

  my $doc           = shift;
  my $except        = shift;
  my $s             = shift;

  my $pf_def_name   = shift;
  my $pf_view_name  = shift;

    my $TREE          = $s->attr("TREE");
    my $LOCATION      = $s->attr("LOCATION");
    my $DATEWRITTEN   = $s->attr("DATEWRITTEN");
    my $doc_name_root = $s->attr("DOCNAMEROOT");

    if (&thingy_exists($except, $TREE, $LOCATION, $doc_name_root)) {
        $except->raise_options($doc, $s, 
                               "Entry with this name exists already: "
                             . "\"$doc_name_root\" --- "
                             . "use new-version form?");
      }
  
    if ($pf_def_name eq $pf_view_name) {
        $except->raise_options($doc, $s, "DEF and VIEW files have same name!",
                               "", 
                               "");
      }
  
    unless ( ( ($pf_def_name =~ m/\S/) || 
               ($pf_view_name =~ m/\S/)   ) && 
             ($doc_name_root =~ m/\S/) ) {
        $except->raise_options($doc, $s, 
                               "Must have an entry; " . 
                               "must have at least one upload-file: " . 
                               "DEF: $pf_def_name, " .
                               "VIEW: $pf_view_name.");
      }
 
    unless (&date_time_sensible($DATEWRITTEN)) {
        $except->raise_options($doc, $s, 
                               "Date error: $DATEWRITTEN (dd/mm/yyyy).");
      }

     
  }


# -----------------------------------------------------------------------------
# -- ask user if they really want to upload this?

sub really_do_this() {

  my $doc      = shift;
  my $except   = shift;

  my $REALNAME         = shift;
  my $USERNAME         = shift;
  my $LOCATION         = shift;
  my $TREE             = shift;
  my $AUTHOR           = shift;
  my $DATEWRITTEN     = shift;

  my $path_free_up_file_def  = shift;
  my $path_free_up_file_view = shift;

  my $keywords         = shift;
  my $readme           = shift;
  my $doc_name_root    = shift;

  my $ACTION           = shift;

    my $query = new CGI;

    my $i      = 0;
    my $string = "";

    $string .= "<H1>Really upload this? (ACTION@ $ACTION)</H1>";

    $string .= $query->startform("POST", "upload.pl", &CGI::MULTIPART);

    $string .= "<PRE>\n";
    $string .= "File (def)   : $path_free_up_file_def\n";
    $string .= "File (view)  : $path_free_up_file_view\n";
    $string .= "Entry        : $doc_name_root \n";
    $string .= "Author       : $AUTHOR \n";
    $string .= "Date written : $DATEWRITTEN \n";
    $string .= "Keywords     : $keywords \n";
    $string .= "Readme       : $readme \n";
    $string .= "</PRE>\n";

    $string .= $query->hidden('USERNAME', $USERNAME);
    $string .= $query->hidden('REALNAME', $REALNAME);
    $string .= $query->hidden('LOCATION', $LOCATION);
    $string .= $query->hidden('TREE', $TREE);
    $string .= $query->hidden('FILE_DEF', $path_free_up_file_def);
    $string .= $query->hidden('FILE_VIEW', $path_free_up_file_view);
    $string .= $query->hidden('THINGY', $doc_name_root);
    $string .= $query->hidden('DATEWRITTEN', $DATEWRITTEN);
    $string .= $query->hidden('AUTHOR', $AUTHOR);
    $string .= $query->hidden('KEYWORDS', $keywords);
    $string .= $query->hidden('README', $readme);

####    $string .= $query->hidden('ACTION', $ACTION);
    $string .= "<INPUT TYPE=\"hidden\" NAME=\"ACTION\" VALUE=\"$ACTION\">";

    $string .= "<BR>\n";

    $string .= $query->submit('BUTTON', 'Send Me');
    $string .= $query->submit('BUTTON', 'Cancel');

    $string .= $query->endform;

    return $string;
  }


# -----------------------------------------------------------------------------
# -- actually upload file from some remote place to our place :

sub upload_file () {

  my $doc    = shift;
  my $except = shift;

  my $source_file           = shift;   # ...file/path reported by the browser;
  my $path_free_source_file = shift;   # ...as above, but stripped of any path;
  my $target_file           = shift;   # ...file/path where we're sticking it
                                       #    (could be tmp);

    my $string = "";

    if ($path_free_source_file =~ m/\S/) {

        open(UPDEF, ">$target_file")
            || $except->raise_integrity($doc, 
                                        "Unable to write, $target_file, " 
                                      . "file to server");

        $doc->append("\n<BR>Gonna start uploading: " . 
                     "<B><TT>$source_file</TT></B>...");

        my $i = 0;
        while (<$source_file>) {
            print UPDEF $_;
            $i++;
          }
        close(UPDEF);

        my $size = (stat $target_file)[7];

        $string .= "\n<BR>Uploaded file(source: $source_file) : $size bytes.<BR>\n";
      }

    return $string;
  }


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
